#ifndef _dynamicclient_hpp
#define _dynamicclient_hpp

#include <QObject>
#include <QSharedPointer>

#include <QRemoteObjectNode>
#include <qremoteobjectdynamicreplica.h>
#include <QAbstractItemModelReplica>

class QQmlApplicationEngine;

class AQmlRemoteObjectHelperHeaderModel : public QAbstractListModel
 {
      Q_OBJECT

public:
      AQmlRemoteObjectHelperHeaderModel(QObject* pParent, QSharedPointer<QAbstractItemModelReplica> ptr, Qt::Orientation ori);
      ~AQmlRemoteObjectHelperHeaderModel() override;

      int rowCount(const QModelIndex & = QModelIndex()) const override;

//      int columnCount(const QModelIndex & = QModelIndex()) const override;

      QVariant data(const QModelIndex &index, int role) const override;

      QHash<int, QByteArray> roleNames() const override;

public slots:
      void handleHeaderDataChanged_slot(Qt::Orientation ori, int nFirst, int nLast);
      void handleBeginReset_slot();
      void handleEndReset_slot();
private:
      QSharedPointer<QAbstractItemModelReplica> m_parentModel{nullptr};
      Qt::Orientation m_orientation;
};

class DynamicClient : public QObject
{
    Q_OBJECT
public:
    DynamicClient(QRemoteObjectNode& repNode, QQmlApplicationEngine& engine);
    ~DynamicClient() override;

public Q_SLOTS:
    void init_slot();

private:
    QSharedPointer<QAbstractItemModelReplica> m_ptrTestModel;
    QSharedPointer<QRemoteObjectDynamicReplica> m_ptrTestControler;

    QQmlApplicationEngine& m_engine;

    AQmlRemoteObjectHelperHeaderModel* m_pTestHorzHeader{nullptr};
};


#endif

