#include <QApplication>
#include <QRemoteObjectHost>

#include "tablemodel.hpp"

int main(int argc, char *argv[])
{
    QGuiApplication app(argc, argv);

    AQmlTableModel model;
    AQmlProxyModel proxy;
    QObject::connect(&proxy, &AQmlProxyModel::sigReloadData, &model, &AQmlTableModel::reloadData);
    proxy.setDynamicSortFilter(true);
    proxy.setSourceModel(&model);

    QRemoteObjectHost hostNode(QUrl(QStringLiteral("local:test")));
    hostNode.enableRemoting(&proxy, QStringLiteral("TestModel"), QVector<int>() << Qt::DisplayRole );
    hostNode.enableRemoting(&proxy, QStringLiteral("TestControler") );

    qDebug() << QLatin1String("Calling exec");
    return app.exec();
}
