#include <QDebug>
#include "tablemodel.hpp"

AQmlTableModel::AQmlTableModel()
    : QAbstractTableModel()
{
    numbers << "1" << "2" << "3" << "4" << "5";
    characters << "A" << "B" << "C" << "D" << "E" << "F" << "G" << "H" << "I" << "K";
}

AQmlTableModel::~AQmlTableModel()
{
 //   delete _padb;
}
int AQmlTableModel::rowCount(const QModelIndex&) const
{
    if( isDisplayNumbers )
        return numbers.size();
    else
        return characters.size();
}

int AQmlTableModel::columnCount(const QModelIndex&) const
{
    if( isDisplayNumbers )
        return numbers.size();
    else
        return characters.size();
}

QVariant AQmlTableModel::data(const QModelIndex& index, int role) const
{
    switch (role) {
        case Qt::DisplayRole:
            if( isDisplayNumbers )
                return QString("%1, %2(%3)").arg(index.column()).arg(index.row()).arg(numbers[index.column()]);
            else
                return QString("%1, %2(%3)").arg(index.column()).arg(index.row()).arg(characters[index.column()]);
        default:
            break;
    }

    return QVariant();
}

QVariant AQmlTableModel::headerData(int section, Qt::Orientation orientation, int role) const
{
    switch (role) {
        case Qt::DisplayRole:
        {
            if(orientation == Qt::Horizontal)
            {
                if( isDisplayNumbers )
                    return section < numbers.size() ? numbers[section] : "ERROR";
                else
                    return section < characters.size() ? characters[section] : "ERROR";
            }
        }
        default:
            break;
    }

    return QVariant();
}


void AQmlTableModel::reloadData(bool displayNumbers)
{
    beginResetModel();

    isDisplayNumbers = displayNumbers;
    
    endResetModel();
}

// ################## Proxy

void AQmlProxyModel::reloadData(bool displayNumbers)
{
    emit sigReloadData(displayNumbers);
}

void AQmlProxyModel::filter_slot(const QString& rxpattern)
{
    setFilterRegularExpression(rxpattern);
    invalidateFilter();
}

void AQmlProxyModel::sort_slot(int column)
{
    static Qt::SortOrder order = Qt::AscendingOrder;
    order = (order == Qt::AscendingOrder ? Qt::DescendingOrder : Qt::AscendingOrder);
    sort(column, order);
    invalidate();
}
