#ifndef QMLTABLEMODEL_HPP
#define QMLTABLEMODEL_HPP

#include <QAbstractTableModel>
#include <QSortFilterProxyModel>

class AQmlTableModel : public QAbstractTableModel
  {
      Q_OBJECT

  public:
      AQmlTableModel();
      ~AQmlTableModel() override;

      int rowCount(const QModelIndex & = QModelIndex()) const override;
      int columnCount(const QModelIndex & = QModelIndex()) const override;
      QVariant data(const QModelIndex &index, int role) const override;
      QVariant headerData(int section, Qt::Orientation orientation, int role) const override;
public slots:
      void reloadData(bool displayNumbers);
private:
    bool isDisplayNumbers{true};
    QStringList numbers;
    QStringList characters;
};

class AQmlProxyModel : public QSortFilterProxyModel
  {
      Q_OBJECT
public:
    AQmlProxyModel() : QSortFilterProxyModel(){}
signals:
      void sigReloadData(bool);
public slots:
      void sort_slot(int column);
      void filter_slot(const QString& rxpattern);
      void reloadData(bool displayNumbers);
};

#endif // QMLTABLEMODEL_HPP
